package com.hzya.frame.plugin.lets.dingtalk.service.impl;

import cn.hutool.core.lang.Assert;
import cn.hutool.json.JSONUtil;
import com.aliyun.dingtalkoauth2_1_0.models.GetAccessTokenResponseBody;
import com.aliyun.dingtalkworkflow_1_0.models.GetProcessInstanceResponse;
import com.aliyun.dingtalkworkflow_1_0.models.GetProcessInstanceResponseBody;
import com.dingtalk.api.response.OapiV2UserGetResponse;
import com.hzya.frame.page.PageAttribute;
import com.hzya.frame.plugin.lets.constant.OverallConstant;
import com.hzya.frame.plugin.lets.constant.ProfilesActiveConstant;
import com.hzya.frame.plugin.lets.dao.IArapDjzbDao;
import com.hzya.frame.plugin.lets.dingtalk.callback.service.impl.CallBackServiceImpl;
import com.hzya.frame.plugin.lets.dingtalk.entity.DingU8cBillEntity;
import com.hzya.frame.plugin.lets.dingtalk.dao.IDingU8cBillDao;
import com.hzya.frame.plugin.lets.dingtalk.service.IDingU8cBillService;
import com.hzya.frame.plugin.lets.dingtalk.utils.DingTalkUtils;
import com.hzya.frame.plugin.lets.entity.ArapDjzbEntity;
import com.hzya.frame.plugin.lets.util.pushData.Attribute;
import com.hzya.frame.plugin.lets.util.pushData.PushU8CByApiCode;
import com.hzya.frame.plugin.lets.util.pushData.ZTResult;
import org.apache.commons.httpclient.HttpClient;
import org.apache.commons.httpclient.methods.PostMethod;
import org.apache.commons.httpclient.methods.RequestEntity;
import org.apache.commons.httpclient.methods.StringRequestEntity;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;
import org.springframework.beans.factory.annotation.Autowired;
import javax.annotation.Resource;
import com.hzya.frame.basedao.service.impl.BaseService;

import java.io.IOException;
import java.time.LocalDate;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * (DingU8cBill)表服务实现类
 *
 * @author makejava
 * @since 2024-10-28 15:45:32
 */
@Service(value = "dingU8cBillServiceImpl")
public class DingU8cBillServiceImpl extends BaseService<DingU8cBillEntity, String> implements IDingU8cBillService {

	@Value("${DING.APPKEY}")
	private String APPKEY;
	@Value("${DING.AppSecret}")
	private String AppSecret;
     
    private IDingU8cBillDao dingU8cBillDao;
    
    @Autowired
	public void setDingU8cBillDao(IDingU8cBillDao dao) {
		this.dingU8cBillDao = dao;
		this.dao = dao;
	}

	@Autowired
	private CallBackServiceImpl callBackService;

	@Override
	public PageAttribute<DingU8cBillEntity> queryPaged(DingU8cBillEntity baseEntity) {
		PageAttribute<DingU8cBillEntity> dingU8cBillEntityPageAttribute = dingU8cBillDao.queryPaged(baseEntity);
		System.out.println(dingU8cBillEntityPageAttribute);
		return dingU8cBillEntityPageAttribute;
	}

	@Override
	public List<DingU8cBillEntity> query(DingU8cBillEntity entity) {
		if (entity.getStart_time() != null && entity.getEnd_time() != null) {
			entity.setStart_time(entity.getStart_time()+" 00:00:00");
			entity.setEnd_time(entity.getEnd_time()+" 23:59:58");
		}
		if("Y,N".equals(entity.getPush_status())||"N,Y".equals(entity.getPush_status())){//"Y,N"
			entity.setPush_status(null);
		}
		if("Y,N".equals(entity.getApprove())||"N,Y".equals(entity.getApprove())){//"Y,N"
			entity.setApprove(null);
		}
		if("U,D".equals(entity.getInitiate())||"D,U".equals(entity.getInitiate())){//"Y,N"
			entity.setInitiate(null);
		}
		List<DingU8cBillEntity> dingU8cBillEntityList = super.query(entity);
		return dingU8cBillEntityList;
	}

	@Override
	public DingU8cBillEntity queryById(DingU8cBillEntity dingU8cBillEntity) {
		try{
			Assert.notNull(dingU8cBillEntity,"dingU8cBillEntity不能未空");
			Assert.notNull(dingU8cBillEntity.getId(),"ID不能未空");
			dingU8cBillEntity.setInitiate(null);
			List<DingU8cBillEntity> query = dingU8cBillDao.query(dingU8cBillEntity);
			if(query.size()==0){
				Assert.state(false,"根据id：{},查询失败，未查询到数据。",dingU8cBillEntity.getId());
			}
			return query.get(0);
		}catch (Exception e){
			Assert.state(false,e.getMessage());
		}
		return null;
	}

	/**
	 * 没有推送成功的，不允许重推，请到u8c重推
	 * 推送成功的，查询审批状态
	 *
	 * 钉钉发起：有实例id，但是没有推送成功
	 *
	 *
	 * @return
	 */
	@Override
	public DingU8cBillEntity pushById(DingU8cBillEntity dingU8cBillEntity) {

		DingU8cBillEntity dingU8cBillEntityNew=null;

		Assert.notNull(dingU8cBillEntity,"dingU8cBillEntity不能未空");
		Assert.notNull(dingU8cBillEntity.getId(),"ID不能未空");
		dingU8cBillEntity.setInitiate(null);
		List<DingU8cBillEntity> query = dingU8cBillDao.query(dingU8cBillEntity);
		try{
			if(query.size()==0){
				Assert.state(false,"根据id：{},查询失败，未查询到数据。",dingU8cBillEntity.getId());
			}
			dingU8cBillEntityNew = query.get(0);

			//没有推送成功的
			if(dingU8cBillEntityNew.getDing_talk_process_id()==null||"".equals(dingU8cBillEntityNew.getDing_talk_process_id().trim())){
				Assert.state(false,"请到U8C系统中进行重新推送。");
			}
			//获取token
			String token = getDingTalkToken();

			//钉钉发起
			if ("D".equals(dingU8cBillEntityNew.getInitiate())) {
				callBackService.addArapBill(dingU8cBillEntityNew.getDing_talk_process_id(),token);
				return dingU8cBillEntityNew;
			}

			//查询实例的具体信息
			GetProcessInstanceResponse processInstanceDetails = DingTalkUtils.getProcessInstanceDetails(token, dingU8cBillEntityNew.getDing_talk_process_id());
			GetProcessInstanceResponseBody.GetProcessInstanceResponseBodyResult processInstanceResponseBodyResult = processInstanceDetails.getBody().getResult();

			String status = null;//审批状态。RUNNING：审批中 TERMINATED：已撤销 COMPLETED：审批完成
			String result = null;//审批结果。agree：同意 refuse：拒绝

			status = processInstanceResponseBodyResult.getStatus();
			if ("RUNNING".equals(status) || "TERMINATED".equals(status)) {
				//审批中、已撤销不处理
				Assert.state(false,"根据公司编码：{}，单据号：{}，实例id：{}补推失败，该审批实例在审批中或已被撤销请检查。"
						,dingU8cBillEntityNew.getU8c_code_corp(),dingU8cBillEntityNew.getU8c_bill_code(),dingU8cBillEntityNew.getDing_talk_process_id());
			}
			//查询u8c的单据状态//spzt：1审核 null 未审核
			String u8cPkCorp = dingU8cBillEntityNew.getU8c_pk_corp();
			String u8cBillCode = dingU8cBillEntityNew.getU8c_bill_code();
			ArapDjzbEntity arapDjzbEntity = queryArapDjzbEntity(u8cPkCorp, u8cBillCode);
			if(arapDjzbEntity==null){
				Assert.state(false,"根据公司编码：{}，单据号：{}，未查询到U8C单据，请检查。");
			}


			result = processInstanceResponseBodyResult.getResult();
			if("agree".equals(result)){
				approveArapDjzb(dingU8cBillEntityNew);
			}else if("refuse".equals(result)){
				refuse(dingU8cBillEntityNew);
			}
			return dingU8cBillEntityNew;
		}catch (Exception e){
			if(dingU8cBillEntityNew != null){
				Assert.state(false,"根据公司编码：{}，单据号：{}，实例id：{}补推失败，失败原因：{}"
						,dingU8cBillEntityNew.getU8c_code_corp(),dingU8cBillEntityNew.getU8c_bill_code(),dingU8cBillEntityNew.getDing_talk_process_id(),e.getMessage());
			}else {
				Assert.state(false,e.getMessage());

			}
		}
		return null;
	}

	@Autowired
	private PushU8CByApiCode pushU8CByApiCode;

	public void approveArapDjzb(DingU8cBillEntity dingU8cBillEntity) throws Exception {
		//获取当前时间
		LocalDate now = LocalDate.now();

		Map bills = new HashMap();
		bills.put("djbh", dingU8cBillEntity.getU8c_bill_code());
		bills.put("dwbm", dingU8cBillEntity.getU8c_code_corp());
		bills.put("opinion", "同意");
        bills.put("operatorid", OverallConstant.getOverAllValue("u8cApiZdrCode"));
//		bills.put("operatorid", mobile);
		bills.put("operatedate", now.toString());
		String jsonStr = JSONUtil.toJsonStr(bills);
		jsonStr = "{\"bills\":[" + jsonStr + "]}";
		System.out.println(jsonStr);

		//推送
		String response = "";
		try {
			ZTResult ztResult = pushU8CByApiCode.pushByCode(OverallConstant.getOverAllValue("arapFkInsetCode"), jsonStr);
			//两层判断,一层中台转发,一层u8c返回
			if ("false".equals(ztResult.getFlag())) {
				//转发失败
				response = JSONUtil.toJsonStr(ztResult.getAttribute());
				Assert.state(false, "丽知：审核付款单审核失败,失败原因:{}", ztResult.getAttribute());
			}
			Attribute attribute = ztResult.getAttribute();
			boolean isSuccess = false;
			if ("success".equals(attribute.getStatus())) {
				isSuccess = true;
			}
			if (!isSuccess) {
				Assert.state(false, "推送U8C--> 丽知：审核付款单审核 失败 接口返回结果：{} ", response);
			}
			//成功
			dingU8cBillEntity.setApprove("Y");
			dingU8cBillDao.callBackSaveOrUpdate(dingU8cBillEntity);
		} catch (Exception e) {
			logger.error("推送U8C--> 丽知：审核付款单审核 失败" + e);
			//失败
			dingU8cBillEntity.setApprove("N");
			dingU8cBillEntity.setPush_info(e.getMessage());
			dingU8cBillDao.callBackSaveOrUpdate(dingU8cBillEntity);
			Assert.state(false,"审核付款单审核失败，失败原因：{}",e.getMessage());
		}

	}

	public void refuse(DingU8cBillEntity dingU8cBillEntity) throws IOException {
		// 服务器访问地址及端口,例如 http://ip:port
		String serviceUrl = OverallConstant.getOverAllValue("u8cApiUrl");
		// 接口地址
		String serviceName = "/u8cloud/api/dev/define";

		//请求头
		Map<String, Object> map = new HashMap<String, Object>();
		map.put("usercode", OverallConstant.getOverAllValue("u8cApiUsercodeCode")); // 用户
		map.put("password", OverallConstant.getOverAllValue("u8cApiPasswordCode")); // 密码，需要 MD5 加密后录入
		map.put("system", OverallConstant.getOverAllValue("u8cApiSystemCode")); // 系统编码
		map.put("custdevpclass", "nc.bs.ding.process.ProcessDingImpl"); //方法路径

		//请求体
		Map<String, String> fileMap = new HashMap<>();
		fileMap.put("instanceId", dingU8cBillEntity.getDing_talk_process_id());
		fileMap.put("userCode", OverallConstant.getOverAllValue("u8cApiZdrCode"));//审批人
		fileMap.put("ckeckResult", "R");
		fileMap.put("ckeckNote", "无");
		String jsonFileMap = JSONUtil.toJsonStr(fileMap);


		//请求
		HttpClient httpClient = new HttpClient();
		PostMethod httpPost = new PostMethod(serviceUrl + serviceName);
		httpPost.setRequestHeader("content-type", "application/json;charset=utf-8");
		for (Map.Entry<String, Object> entry : map.entrySet()) {
			httpPost.setRequestHeader(entry.getKey(), entry.getValue()
					.toString());
		}

		RequestEntity entity = new StringRequestEntity(jsonFileMap, "application/json", "UTF-8");
		httpPost.setRequestEntity(entity);
		httpClient.executeMethod(httpPost);
		String responseBodyAsString = httpPost.getResponseBodyAsString();
		System.out.println(responseBodyAsString);
	}


	public String getDingTalkToken() throws Exception {
		GetAccessTokenResponseBody tokenBody = DingTalkUtils.getTokenBody(APPKEY, AppSecret);
		return tokenBody.getAccessToken();
	}

	public String getMobileByUserId(String token, String userId) {
		OapiV2UserGetResponse user = DingTalkUtils.getUserById(token, userId);
		String mobile = user.getResult().getMobile();
		return mobile;
	}

	@Autowired
	private IArapDjzbDao arapDjzbDao;

	/**
	 * 查询u8c付款单主表
	 */
	public ArapDjzbEntity queryArapDjzbEntity(String u8cPkCorp, String u8cBillCode){
		ArapDjzbEntity arapDjzbEntity = new ArapDjzbEntity();
		arapDjzbEntity.setDr("0");
		arapDjzbEntity.setDwbm(u8cPkCorp);
		arapDjzbEntity.setDjbh(u8cBillCode);
		arapDjzbEntity.setDataSourceCode(ProfilesActiveConstant.LETS_DATE_SOURCE);
		List<ArapDjzbEntity> query = arapDjzbDao.query(arapDjzbEntity);
		if(query.size()==0){
			return null;
		}else {
			return query.get(0);
		}
	}

}
