package com.hzya.frame.plugin.lets.util;

import com.hzya.frame.WebappApplication;
import com.hzya.frame.plugin.lets.ofsvo.QueryOfsSoSaleOutVo;
import com.hzya.frame.ttxofs.dto.ofssalesordersearch.DetailsDto;
import com.hzya.frame.ttxofs.dto.ofssalesordersearch.HeaderDetailsDto;
import com.hzya.frame.ttxofs.dto.ofssalesordersearch.HeaderDto;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.junit4.SpringRunner;

import java.util.ArrayList;
import java.util.List;

import static org.junit.Assert.*;

/**
 * @Author：liuyang
 * @Package：com.hzya.frame.plugin.lets.util
 * @Project：kangarooDataCenterV3
 * @name：AmountAllocationUtilTest
 * @Date：2024/9/22 14:36
 * @Filename：AmountAllocationUtilTest
 */
@RunWith(SpringRunner.class)
@SpringBootTest(classes = WebappApplication.class)
public class AmountAllocationUtilTest {

    Logger logger = LoggerFactory.getLogger(AmountAllocationUtilTest.class);

    @Autowired
    private OfsOrderSaleAmountAllocationUtil ofsOrderSaleAmountAllocationUtil;

    @Autowired
    private OfsStandardUtil ofsStandardUtil;

    @Test
    public void tocSalesAmountAllocation() {
        try {
            List<HeaderDetailsDto> headerDetailsDtoArrayList = new ArrayList<>();
            QueryOfsSoSaleOutVo queryOfsSoSaleOutVo = new QueryOfsSoSaleOutVo();
            queryOfsSoSaleOutVo.setCode("LETS-SO2024041700000003");
            ofsStandardUtil.getOfsSaleOrder(queryOfsSoSaleOutVo, headerDetailsDtoArrayList, 1L);

            if (headerDetailsDtoArrayList.size() > 0) {
                //情况一：所有优惠金额都没有问题
                HeaderDto header = headerDetailsDtoArrayList.get(0).getHeader();
                header.setPlatformDiscounts("3");
                header.setMerchantDiscounts("3");
                header.setExpertDiscounts("3");
                header.setPayDiscounts("1");

                ofsOrderSaleAmountAllocationUtil.tocSalesAmountAllocation(headerDetailsDtoArrayList.get(0));
            }

            HeaderDetailsDto headerDetailsDto = headerDetailsDtoArrayList.get(0);
            List<DetailsDto> details = headerDetailsDto.getDetails();
            for (int i = 0; i < details.size(); i++) {
                DetailsDto detailsDto = details.get(i);

                logger.info("分摊平台优惠：{} 分摊商家优惠：{} 分摊达人优惠：{} 分摊支付优惠：{}", detailsDto.getShareTargetPlatformDiscounts(), detailsDto.getShareTargetMerchantDiscounts(), detailsDto.getShareTargetExpertDiscounts(), detailsDto.getShareTargetPayDiscounts());

            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}